package com.ibm.eis.mdrr.testregistration;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.InputStream;

import javax.xml.transform.Source;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.stream.StreamResult;
import javax.xml.transform.stream.StreamSource;
import javax.xml.ws.Provider;
import javax.xml.ws.Service;
import javax.xml.ws.ServiceMode;
import javax.xml.ws.WebServiceProvider;


@WebServiceProvider(targetNamespace = "http://cmdbf.org/schema/1-0-0/register",
					portName="RegistrationPort",
					serviceName="RegistrationService",
					wsdlLocation="WEB-INF/wsdl/cmdbfRegistrationService.wsdl")
@ServiceMode(value=Service.Mode.PAYLOAD)
public class RegistrationService implements Provider<Source> {
	
	private Transformer _xslTransformer = null;
	
	public RegistrationService() throws Exception {
		InputStream transformInputStream = null;
		try {
			String transformResource = this.getClass().getPackage().getName().replace('.', '/') + "/register.xsl";
			transformInputStream = this.getClass().getClassLoader().getResourceAsStream(transformResource);
			_xslTransformer = TransformerFactory.newInstance().newTransformer(new StreamSource(transformInputStream));

			_xslTransformer.setParameter(CMDBfRegistrationHandler.REGISTRATION_HANDLER_PROPERTY, new DummyRegistrationHandler());
		} finally {
			if (transformInputStream != null) {
				try {
					transformInputStream.close();
				} catch (Exception ex) { }
			}
		}
	}
	
	public Source invoke(Source request) {
		Source retval = null;
		try {
 			ByteArrayOutputStream byteArrayOutputStream = new ByteArrayOutputStream();
			_xslTransformer.transform(request, new StreamResult(byteArrayOutputStream));
			retval = new StreamSource(new ByteArrayInputStream(byteArrayOutputStream.toByteArray()));
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return retval;
	}
}
